﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Architecture.Linq;
using Emerald.Business.Controllers;

namespace Emerald.Business
{
    /// <summary>
    /// 
    /// </summary>
    public partial class User
    {
        private MembershipController m_membershipController;
        private JunctionList<Membership, Role> m_roles;

        private MembershipController MembershipController
        {
            get
            {
                if (m_membershipController == null)
                {
                    m_membershipController = new MembershipController();
                }

                return m_membershipController;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public JunctionList<Membership, Role> Roles
        {
            get
            {
                if (m_roles == null)
                {
                    m_roles = new JunctionList<Membership, Role>(
                        this.Memberships,
                        ur => ur.Role,
                        (ur, r) => ur.Add(new Membership { User = this, Role = r }),
                        delegate(IList<Membership> urs, Role r)
                        {
                            Membership toRemove = urs.Where(ur => ur.Role.Id == r.Id).Single();
                            MembershipController.Delete(toRemove);
                        }
                    );
                }

                return m_roles;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int NumberOfPosts
		{
			get { return Messages.Count; }
		}
    }
}
